package org.example.mybatisplus.Controller;

import com.alibaba.fastjson2.JSONObject;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;

import org.example.mybatisplus.model.auto.CmsEnterpriseRiskInfoCheckBO;
import org.example.mybatisplus.model.auto.CmsEnterpriseRiskInfoDeclaration;
import org.example.mybatisplus.model.auto.CmsEnterpriseRiskQxbInfoBO;
import org.example.mybatisplus.module.*;
import org.example.mybatisplus.module.vo.*;
import org.example.mybatisplus.tools.DocxGenerator;
import org.example.mybatisplus.tools.WordPoiExporter;
import org.example.mybatisplus.tools.WordToPdfUtil;
import org.springframework.core.io.FileSystemResource;
import org.springframework.core.io.Resource;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;

import java.io.*;

@ApiOperation("控制类")
@RestController
public class IndexController {
    public static void main(String[] args) throws IOException {

        String wordExportpath = System.getProperty("user.dir")+File.separator+ "jijinhui1.docx";
        String pdfFilePath =System.getProperty("user.dir")+File.separator+  "download.pdf";

        ServiceProviderInfo serviceProviderInfo=new ServiceProviderInfo();
        serviceProviderInfo.setName("海潮基金会");
        serviceProviderInfo.setType("基金会");
        serviceProviderInfo.setReportDate("2025-03-11");
        AuditResult auditResult=new AuditResult();
        auditResult.setAuditDate("2025-03-11");
        auditResult.setScore("222");
        auditResult.setOpinion("test");
        auditResult.setServiceProviderName("服务商2");

        BasicInfo basicInfo = new BasicInfo();
        basicInfo.setBasicInfoScore(new BasicInfoScore(
                66l,
                "哈哈哈",
                "测试"
        ));
        // 将图片转换为 Base64 编码
        String imageBase64 = DocxGenerator.convertImageToBase64("G:\\Code\\new\\fxy-tool\\src\\main\\resources\\pic1.png");
        Attachment attach = new Attachment();
        attach.setFileName("关联实体情况.png");

        attach.setBase64(imageBase64);
        basicInfo.setRelatedEntitiesImage(attach);
        PublicRecord publicRecord=new PublicRecord();
        publicRecord.setPublicRecordScore(new PublicRecordScore());
        FinancialInfo financialInfo=new FinancialInfo();
        financialInfo.setFinancialData1(new FinancialData());//new 空对象防止模板空指针
        financialInfo.setFinancialData2(new FinancialData());
        financialInfo.setFinancialData3(new FinancialData());
        financialInfo.setFinancialData4(new FinancialData());
        financialInfo.setFinancialScore(new FinancialScore());
        ProjectInfo projectInfo=new ProjectInfo();
        DocumentVo documentVo=new DocumentVo();

        ServiceProviderAuditReport report=new ServiceProviderAuditReport();
        report.setServiceProviderInfo(serviceProviderInfo);
        report.setAuditResult(auditResult);
        report.setBasicInfo(basicInfo);
        report.setPublicRecord(publicRecord);
        report.setFinancialInfo(financialInfo);
        report.setProjectInfo(projectInfo);
        report.setDocumentVo(documentVo);
        try {
            // 生成Word文档
            DocxGenerator.init(report,"n_jjh.xml",wordExportpath);
            // 将Word文档转换为PDF
            WordToPdfUtil.wordToPdf(wordExportpath,pdfFilePath);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    //只要接口中，返回值存在实体类,就会被扫描到swagger中
    @GetMapping("/export")
    public ResponseEntity<Resource> export(@ApiParam("param")String param /* todo: 参数：服务商ID，校验ID，报告类型*/){

        String wordFilePath = System.getProperty("user.dir")+File.separator+ "jijinhui.docx";
        String wordExportpath = System.getProperty("user.dir")+File.separator+ "jijinhui1.docx";
        String pdfFilePath =System.getProperty("user.dir")+File.separator+  "download.pdf";

        // todo:
        ServiceProviderInfo serviceProviderInfo=new ServiceProviderInfo();
        serviceProviderInfo.setName("海潮基金会");
        serviceProviderInfo.setReportDate("2025-03-24");
        // 1. getWordTemplate for BasicInfo
        // 2. retrieve data
        //    2.1 get CmsEnterpriseRiskQxbInfoBO
        CmsEnterpriseRiskQxbInfoBO cmsEnterpriseRiskQxbInfoBO = org.example.mybatisplus.model.auto.CmsEnterpriseRiskQxbInfoBO.builder().build(); // mock
        CmsEnterpriseRiskInfoDeclaration cmsEnterpriseRiskInfoDeclaration = new CmsEnterpriseRiskInfoDeclaration(); // mock
        CmsEnterpriseRiskInfoCheckBO cmsEnterpriseRiskInfoCheckBO = new CmsEnterpriseRiskInfoCheckBO();

        // 3. fill 
        AuditResult auditResult=new AuditResult();
        auditResult.setReportVersion("PLUS版");
        auditResult.setServiceProviderName("上海医药行业协会");
        cmsEnterpriseRiskQxbInfoBO.fillAuditResultVO(auditResult);
        cmsEnterpriseRiskInfoDeclaration.fillAuditResultVO(auditResult);
        cmsEnterpriseRiskInfoCheckBO.fillAuditResultVO(auditResult);


        BasicInfo basicInfo = new BasicInfo();
        cmsEnterpriseRiskQxbInfoBO.fillBasicInfoVO(basicInfo);
        cmsEnterpriseRiskInfoDeclaration.fillBasicInfoVO(basicInfo);
        cmsEnterpriseRiskInfoCheckBO.fillBasicInfoVO(basicInfo);

        // 4. render WordTemplate with BasicInfo

        // ...

        // 最后把所有片段合成一个完整报告

        ServiceProviderAuditReport report=new ServiceProviderAuditReport();
        report.setServiceProviderInfo(serviceProviderInfo);
        report.setBasicInfo(basicInfo);
        report.setAuditResult(auditResult);
        try {
            //JSONObject jsonObject = JSONObject.parseObject(JSONObject.toJSONString(report));
            // 生成Word文档
            //WordPoiExporter.init(wordFilePath,wordExportpath,jsonObject);
            // 生成Word文档
            DocxGenerator.init(report,"n_jjh.xml",wordExportpath);
            // 将Word文档转换为PDF
            WordToPdfUtil.wordToPdf(wordExportpath,pdfFilePath);
        } catch (Exception e) {
            e.printStackTrace();
        }

        File file = new File(pdfFilePath);
        Resource resource = new FileSystemResource(file);

        HttpHeaders headers = new HttpHeaders();
        headers.add(HttpHeaders.CONTENT_DISPOSITION, "attachment; filename=" + file.getName());

        return ResponseEntity.ok()
                .headers(headers)
                .contentLength(file.length())
                .contentType(MediaType.APPLICATION_PDF)
                .body(resource);
    }


}
