package org.example.mybatisplus.tools;

import cn.hutool.extra.template.TemplateException;
import freemarker.template.Configuration;
import freemarker.template.Template;
import org.example.mybatisplus.module.*;
import org.example.mybatisplus.module.vo.*;

import java.io.*;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.Base64;

public class DocxGenerator {
    public static void init(ServiceProviderAuditReport report,String templatePath,String outpath) {
        // 配置 Freemarker
        Configuration cfg = new Configuration(Configuration.VERSION_2_3_31);
        try {
            // 设置模板文件所在的目录
            cfg.setClassForTemplateLoading(DocxGenerator.class, "/");

            // 加载模板
            Template template = cfg.getTemplate(templatePath);

            // 输出文件
            File outputFile = new File(outpath);
            try (Writer out = new FileWriter(outputFile)) {
                // 处理模板并输出到文件
                template.process(report, out);
                System.out.println("XML file generated successfully: " + outputFile.getAbsolutePath());
            } catch (Exception e) {
                throw new RuntimeException(e);
            }
        } catch (IOException | TemplateException e) {
            e.printStackTrace();
        }
    }

    /**
     * 将图片转换为 Base64 编码
     * @param imagePath 图片的文件路径
     * @return Base64 编码的字符串
     * @throws IOException 读取文件时可能抛出的异常
     */
    public static String convertImageToBase64(String imagePath) throws IOException {
        Path path = Paths.get(imagePath);
        byte[] imageBytes = Files.readAllBytes(path);
        return Base64.getEncoder().encodeToString(imageBytes);
    }
}
